=== src/Mod/Fem/CMakeLists.txt ===

if(BUILD_FEM_VTK)
    add_definitions(-DFC_USE_VTK)
endif(BUILD_FEM_VTK)


# suppress warnings from smesh
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-overloaded-virtual")
endif()


# ************************************************************************************************
# ****** sub directories**************************************************************************
# ************************************************************************************************

add_subdirectory(App)

if(BUILD_GUI)
    add_subdirectory(Gui)
endif(BUILD_GUI)



# ************************************************************************************************
# ****** Python non Gui packages and modules *****************************************************
# ************************************************************************************************

SET(FemBaseModules_SRCS
    coding_conventions.md
    Init.py
    InitGui.py
    ObjectsFem.py
    TestFemApp.py
)

SET(FemCommands_SRCS
    femcommands/__init__.py
    femcommands/commands.py
    femcommands/manager.py
)

SET(FemExamples_SRCS
    femexamples/__init__.py
    femexamples/boxanalysis_base.py
    femexamples/boxanalysis_static.py
    femexamples/boxanalysis_frequency.py
    femexamples/buckling_platebuckling.py
    femexamples/buckling_lateraltorsionalbuckling.py
    femexamples/ccx_buckling_flexuralbuckling.py
    femexamples/ccx_cantilever_base_edge.py
    femexamples/ccx_cantilever_base_face.py
    femexamples/ccx_cantilever_base_solid.py
    femexamples/ccx_cantilever_beam_circle.py
    femexamples/ccx_cantilever_beam_pipe.py
    femexamples/ccx_cantilever_beam_rect.py
    femexamples/ccx_cantilever_ele_hexa20.py
    femexamples/ccx_cantilever_ele_quad4.py
    femexamples/ccx_cantilever_ele_quad8.py
    femexamples/ccx_cantilever_ele_tetra4.py
    femexamples/ccx_cantilever_ele_tria3.py
    femexamples/ccx_cantilever_ele_tria6.py
    femexamples/ccx_cantilever_ele_seg2.py
    femexamples/ccx_cantilever_ele_seg3.py
    femexamples/ccx_cantilever_faceload.py
    femexamples/ccx_cantilever_nodeload.py
    femexamples/ccx_cantilever_prescribeddisplacement.py
    femexamples/constraint_centrif.py
    femexamples/constraint_contact_shell_shell.py
    femexamples/constraint_contact_solid_solid.py
    femexamples/constraint_section_print.py
    femexamples/constraint_selfweight_cantilever.py
    femexamples/constraint_tie.py
    femexamples/constraint_transform_beam_hinged.py
    femexamples/constraint_transform_torque.py
    femexamples/examplesgui.py
    femexamples/elmer_nonguitutorial01_eigenvalue_of_elastic_beam.py
    femexamples/equation_deformation_spring_elmer.py
    femexamples/equation_electrostatics_capacitance_two_balls.py
    femexamples/equation_electrostatics_electricforce_elmer_nongui6.py
    femexamples/equation_flow_elmer_2D.py
    femexamples/equation_flow_initial_elmer_2D.py
    femexamples/equation_flow_turbulent_elmer_2D.py
    femexamples/equation_flux_elmer.py
    femexamples/equation_magnetodynamics_elmer.py
    femexamples/equation_magnetodynamics_2D_elmer.py
    femexamples/equation_magnetostatics_2D_elmer.py
    femexamples/frequency_beamsimple.py
    femexamples/manager.py
    femexamples/material_multiple_bendingbeam_fiveboxes.py
    femexamples/material_multiple_bendingbeam_fivefaces.py
    femexamples/material_multiple_tensionrod_twoboxes.py
    femexamples/material_nl_platewithhole.py
    femexamples/mystran_plate.py
    femexamples/rc_wall_2d.py
    femexamples/square_pipe_end_twisted_edgeforces.py
    femexamples/square_pipe_end_twisted_nodeforces.py
    femexamples/thermomech_bimetal.py
    femexamples/truss_3d_cs_circle_ele_seg2.py
    femexamples/truss_3d_cs_circle_ele_seg3.py
)


SET(FemExampleMeshes_SRCS
    femexamples/meshes/__init__.py
    femexamples/meshes/mesh_beamsimple_tetra10.py
    femexamples/meshes/mesh_boxanalysis_tetra10.py
    femexamples/meshes/mesh_boxes_2_vertikal_tetra10.py
    femexamples/meshes/mesh_buckling_ibeam_tria6.py
    femexamples/meshes/mesh_buckling_plate_tria6.py
    femexamples/meshes/mesh_canticcx_hexa20.py
    femexamples/meshes/mesh_canticcx_quad4.py
    femexamples/meshes/mesh_canticcx_quad8.py
    femexamples/meshes/mesh_canticcx_seg2.py
    femexamples/meshes/mesh_canticcx_seg3.py
    femexamples/meshes/mesh_canticcx_tetra10.py
    femexamples/meshes/mesh_canticcx_tria3.py
    femexamples/meshes/mesh_canticcx_tria6.py
    femexamples/meshes/mesh_capacitance_two_balls_tetra10.py
    femexamples/meshes/mesh_constraint_centrif_tetra10.py
    femexamples/meshes/mesh_constraint_tie_tetra10.py
    femexamples/meshes/mesh_contact_box_halfcylinder_tetra10.py
    femexamples/meshes/mesh_contact_tube_tube_tria3.py
    femexamples/meshes/mesh_eigenvalue_of_elastic_beam_tetra10.py
    femexamples/meshes/mesh_electricforce_elmer_nongui6_tetra10.py
    femexamples/meshes/mesh_flexural_buckling.py
    femexamples/meshes/mesh_multibodybeam_tetra10.py
    femexamples/meshes/mesh_multibodybeam_tria6.py
    femexamples/meshes/mesh_plate_mystran_quad4.py
    femexamples/meshes/mesh_platewithhole_tetra10.py
    femexamples/meshes/mesh_rc_wall_2d_tria6.py
    femexamples/meshes/mesh_section_print_tetra10.py
    femexamples/meshes/mesh_selfweight_cantilever_tetra10.py
    femexamples/meshes/mesh_square_pipe_end_twisted_tria6.py
    femexamples/meshes/mesh_thermomech_bimetal_tetra10.py
    femexamples/meshes/mesh_transform_beam_hinged_tetra10.py
    femexamples/meshes/mesh_transform_torque_tetra10.py
    femexamples/meshes/mesh_truss_crane_seg2.py
    femexamples/meshes/mesh_truss_crane_seg3.py
)

SET(FemInOut_SRCS
    feminout/__init__.py
    feminout/convert2TetGen.py
    feminout/exportNastranMesh.py
    feminout/importCcxDatResults.py
    feminout/importCcxFrdResults.py
    feminout/importFenicsMesh.py
    feminout/importInpMesh.py
    feminout/importPyMesh.py
    feminout/importToolsFem.py
    feminout/importVTKResults.py
    feminout/importYamlJsonMesh.py
    feminout/importZ88Mesh.py
    feminout/importZ88O2Results.py
    feminout/readFenicsXDMF.py
    feminout/readFenicsXML.py
    feminout/writeFenicsXDMF.py
    feminout/writeFenicsXML.py
)

SET(FemMesh_SRCS
    femmesh/__init__.py
    femmesh/femmesh2mesh.py
    femmesh/gmshtools.py
    femmesh/meshsetsgetter.py
    femmesh/meshtools.py
)

SET(FemObjects_SRCS
    femobjects/__init__.py
    femobjects/base_femelement.py
    femobjects/base_femmeshelement.py
    femobjects/base_fempythonobject.py
    femobjects/constant_vacuumpermittivity.py
    femobjects/constraint_bodyheatsource.py
    femobjects/constraint_centrif.py
    femobjects/constraint_currentdensity.py
    femobjects/constraint_electrostaticpotential.py
    femobjects/constraint_flowvelocity.py
    femobjects/constraint_initialflowvelocity.py
    femobjects/constraint_initialpressure.py
    femobjects/constraint_magnetization.py
    femobjects/constraint_sectionprint.py
    femobjects/constraint_selfweight.py
    femobjects/constraint_tie.py
    femobjects/element_fluid1D.py
    femobjects/element_geometry1D.py
    femobjects/element_geometry2D.py
    femobjects/element_rotation1D.py
    femobjects/material_common.py
    femobjects/material_mechanicalnonlinear.py
    femobjects/material_reinforced.py
    femobjects/mesh_boundarylayer.py
    femobjects/mesh_gmsh.py
    femobjects/mesh_group.py
    femobjects/mesh_region.py
    femobjects/mesh_result.py
    femobjects/result_mechanical.py
    femobjects/solver_ccxtools.py
)

SET(FemResult_SRCS
    femresult/__init__.py
    femresult/resulttools.py
)

SET(FemSolver_SRCS
    femsolver/__init__.py
    femsolver/equationbase.py
    femsolver/report.py
    femsolver/reportdialog.py
    femsolver/run.py
    femsolver/settings.py
    femsolver/signal.py
    femsolver/solver_taskpanel.py
    femsolver/solverbase.py
    femsolver/task.py
    femsolver/writerbase.py
)

SET(FemSolverCalculix_SRCS
    femsolver/calculix/__init__.py
    femsolver/calculix/solver.py
    femsolver/calculix/tasks.py
    femsolver/calculix/write_constraint_bodyheatsource.py
    femsolver/calculix/write_constraint_centrif.py
    femsolver/calculix/write_constraint_contact.py
    femsolver/calculix/write_constraint_displacement.py
    femsolver/calculix/write_constraint_fixed.py
    femsolver/calculix/write_constraint_fluidsection.py
    femsolver/calculix/write_constraint_force.py
    femsolver/calculix/write_constraint_heatflux.py
    femsolver/calculix/write_constraint_initialtemperature.py
    femsolver/calculix/write_constraint_planerotation.py
    femsolver/calculix/write_constraint_pressure.py
    femsolver/calculix/write_constraint_rigidbody.py
    femsolver/calculix/write_constraint_rigidbody_step.py
    femsolver/calculix/write_constraint_sectionprint.py
    femsolver/calculix/write_constraint_selfweight.py
    femsolver/calculix/write_constraint_temperature.py
    femsolver/calculix/write_constraint_tie.py
    femsolver/calculix/write_constraint_transform.py
    femsolver/calculix/write_femelement_geometry.py
    femsolver/calculix/write_femelement_material.py
    femsolver/calculix/write_femelement_matgeosets.py
    femsolver/calculix/write_footer.py
    femsolver/calculix/write_mesh.py
    femsolver/calculix/write_step_equation.py
    femsolver/calculix/write_step_output.py
    femsolver/calculix/writer.py
)

SET(FemSolverElmer_SRCS
    femsolver/elmer/__init__.py
    femsolver/elmer/sifio.py
    femsolver/elmer/solver.py
    femsolver/elmer/tasks.py
    femsolver/elmer/writer.py
)

SET(FemSolverElmerEquations_SRCS
    femsolver/elmer/equations/__init__.py
    femsolver/elmer/equations/deformation.py
    femsolver/elmer/equations/deformation_writer.py
    femsolver/elmer/equations/elasticity.py
    femsolver/elmer/equations/elasticity_writer.py
    femsolver/elmer/equations/electricforce.py
    femsolver/elmer/equations/electricforce_writer.py
    femsolver/elmer/equations/electrostatic.py
    femsolver/elmer/equations/electrostatic_writer.py
    femsolver/elmer/equations/equation.py
    femsolver/elmer/equations/flow.py
    femsolver/elmer/equations/flow_writer.py
    femsolver/elmer/equations/flux.py
    femsolver/elmer/equations/flux_writer.py
    femsolver/elmer/equations/heat.py
    femsolver/elmer/equations/heat_writer.py
    femsolver/elmer/equations/linear.py
    femsolver/elmer/equations/magnetodynamic.py
    femsolver/elmer/equations/magnetodynamic_writer.py
    femsolver/elmer/equations/magnetodynamic2D.py
    femsolver/elmer/equations/magnetodynamic2D_writer.py
    femsolver/elmer/equations/nonlinear.py
)

SET(FemSolverFenics_SRCS
    femsolver/fenics/__init__.py
    femsolver/fenics/fenics_tools.py
)

SET(FemSolverMystran_SRCS
    femsolver/mystran/__init__.py
    femsolver/mystran/add_con_fixed.py
    femsolver/mystran/add_con_force.py
    femsolver/mystran/add_femelement_geometry.py
    femsolver/mystran/add_femelement_material.py
    femsolver/mystran/add_mesh.py
    femsolver/mystran/add_solver_control.py
    femsolver/mystran/solver.py
    femsolver/mystran/tasks.py
    femsolver/mystran/writer.py
)

SET(FemSolverZ88_SRCS
    femsolver/z88/__init__.py
    femsolver/z88/solver.py
    femsolver/z88/tasks.py
    femsolver/z88/writer.py
)

SET(FemTests_SRCS
    femtest/__init__.py
    femtest/test_commands.sh
    femtest/test_information.md
)

SET(FemTestsApp_SRCS
    femtest/app/__init__.py
    femtest/app/support_utils.py
    femtest/app/test_ccxtools.py
    femtest/app/test_common.py
    femtest/app/test_femimport.py
    femtest/app/test_material.py
    femtest/app/test_mesh.py
    femtest/app/test_object.py
    femtest/app/test_open.py
    femtest/app/test_result.py
    femtest/app/test_solver_elmer.py
    femtest/app/test_solver_mystran.py
    femtest/app/test_solver_z88.py
)

SET(FemTestsFiles_SRCS
    femtest/data/__init__.py
)

SET(FemTestsCcx_SRCS
    femtest/data/calculix/__init__.py
    femtest/data/calculix/box_frequency.inp
